
(cffi:load-foreign-library #P"run_function.so")

(cffi:defcfun ("run_function" run-function) :void (callback :pointer))

(cffi:defcallback mycallback :void ()
  (format t "Hooray! Made it into the callback!~%"))

(defun main ()
  (handler-case 
      (progn
        (format t "Started main~%")
        (run-function (cffi:callback mycallback))
        (format t "Finishing main~%"))
    (error (e)
      (format *error-output* "Failed with error: ~a~%" e))))
